VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Line Line1 
      Index           =   1
      X1              =   360
      X2              =   1200
      Y1              =   1920
      Y2              =   240
   End
   Begin VB.Line Line1 
      Index           =   2
      X1              =   2040
      X2              =   960
      Y1              =   480
      Y2              =   2640
   End
   Begin VB.Line Line1 
      Index           =   3
      X1              =   1800
      X2              =   4560
      Y1              =   1320
      Y2              =   1440
   End
   Begin VB.Line Line1 
      Index           =   6
      X1              =   3720
      X2              =   3480
      Y1              =   960
      Y2              =   2040
   End
   Begin VB.Line Line1 
      Index           =   4
      X1              =   840
      X2              =   4080
      Y1              =   1800
      Y2              =   3120
   End
   Begin VB.Line Line1 
      Index           =   5
      X1              =   2640
      X2              =   1920
      Y1              =   600
      Y2              =   1920
   End
   Begin VB.Line Line1 
      Index           =   0
      X1              =   240
      X2              =   1440
      Y1              =   360
      Y2              =   840
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_SelectedSegment As Integer
' Calculate the distance between the point and the segment.
Private Function DistToSegment(ByVal px As Single, ByVal py As Single, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByRef near_x As Single, ByRef near_y As Single) As Single
Dim dx As Single
Dim dy As Single
Dim t As Single

    dx = X2 - X1
    dy = Y2 - Y1
    If dx = 0 And dy = 0 Then
        ' It's a point not a line segment.
        dx = px - X1
        dy = py - Y1
        near_x = X1
        near_y = Y1
        DistToSegment = Sqr(dx * dx + dy * dy)
        Exit Function
    End If

    ' Calculate the t that minimizes the distance.
    t = ((px - X1) * dx + (py - Y1) * dy) / (dx * dx + dy * dy)

    ' See if this represents one of the segment's
    ' end points or a point in the middle.
    If t < 0 Then
        dx = px - X1
        dy = py - Y1
        near_x = X1
        near_y = Y1
    ElseIf t > 1 Then
        dx = px - X2
        dy = py - Y2
        near_x = X2
        near_y = Y2
    Else
        near_x = X1 + t * dx
        near_y = Y1 + t * dy
        dx = px - near_x
        dy = py - near_y
    End If

    DistToSegment = Sqr(dx * dx + dy * dy)
End Function

Private Sub Form_Load()
    ' Start with no segment selected.
    m_SelectedSegment = -1
End Sub

' See if the user clicked on a segment.
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
' Maximum distance that counts as a hit.
Const MAX_HIT_DIST = 60

Dim i As Integer
Dim best_i As Integer
Dim best_dist As Single
Dim dist As Single
Dim near_x As Single
Dim near_y As Single

    ' Deselect the previously selected segment.
    If m_SelectedSegment >= 0 Then
        With Line1(m_SelectedSegment)
            .BorderColor = vbBlack
            .BorderWidth = 1
        End With
        m_SelectedSegment = -1
    End If

    ' See which segment is closest to the mouse.
    best_dist = MAX_HIT_DIST + 1
    For i = Line1.LBound To Line1.UBound
        With Line1(i)
            dist = DistToSegment(X, Y, .X1, .Y1, .X2, .Y2, near_x, near_y)
            If dist < best_dist Then
                best_dist = dist
                best_i = i
            End If
        End With
    Next i

    ' See if this is close enough.
    If best_dist <= MAX_HIT_DIST Then
        m_SelectedSegment = best_i
        With Line1(m_SelectedSegment)
            .BorderColor = vbRed
            .BorderWidth = 3
        End With
    End If
End Sub
